package org.pasoa.preserv.index;

import java.util.List;

import org.pasoa.preserv.index.IndexProblem;
import org.pasoa.pstructure.GlobalPAssertionKey;
import org.pasoa.pstructure.InteractionKey;
import org.pasoa.pstructure.InteractionRecord;
import org.pasoa.pstructure.PAssertion;
import org.pasoa.pstructure.View;
import org.w3c.dom.Element;

public interface MyIndex {

	public InteractionRecord findInteractionRecord(InteractionKey key)
			throws IndexProblem;

	public PAssertion findPAssertion(GlobalPAssertionKey gpak)
			throws IndexProblem;

	public List<View> findViews(InteractionKey key, String viewKind)
			throws IndexProblem;

	public View findView(InteractionKey key, String viewKind, Element asserter)
			throws IndexProblem;

}