package org.pasoa.preserv.pquery;

import org.w3c.dom.Document;

public class ProvenanceQueryRequest implements PStructureReference {
    private QueryDataHandle          _queryDataHandle;
    private RelationshipTargetFilter _relationshipTargetFilter;
    
    public ProvenanceQueryRequest (QueryDataHandle queryDataHandle, RelationshipTargetFilter relationshipTargetFilter) {
        _queryDataHandle          = queryDataHandle;
        _relationshipTargetFilter = relationshipTargetFilter;
    }

    public QueryDataHandle getQueryDataHandle () {
        return _queryDataHandle;
    }
    
    public RelationshipTargetFilter getRelationshipTargetFilter () {
        return _relationshipTargetFilter;
    }
    
    /**
     * Will be a p-structure representation of the results of the resolve() method.
     */
    public Document getPStructure () {
        return null;
    }
    
    public String toString () {
        return "QDH: " + _queryDataHandle + "\nRTF: " + _relationshipTargetFilter;
    }
}
