package org.pasoa.preserv.pquery;

import java.util.Collection;

public class ProvenanceQueryResults {
    private Collection _startTemplates;
    private Collection _fullRelationships;
    
    public ProvenanceQueryResults (Collection startTemplates, Collection fullRelationships) {
        _startTemplates    = startTemplates;
        _fullRelationships = fullRelationships;
    }
    
    public Collection getFullRelationships () {
        return _fullRelationships;
    }
    
    public Collection getStarts () {
        return _startTemplates;
    }
    
    public String toString () {
        return "Starts: " + _startTemplates.size () + "\nRelationships: " + _fullRelationships.size ();
    }
}
