package org.pasoa.preserv.servlet.management;

import java.util.Collection;
import java.util.Collections;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;

import org.pasoa.preserv.storage.InitialConfig;

/**
 * @author Andrej Kazakov
 *
 */
public class DefaultInitialConfigImpl implements InitialConfig {

	
	private Map<String, String> conf = new HashMap<String, String> ();

	/* (non-Javadoc)
	 * @see org.pasoa.preserv.storage.InitialConfig#getInitParameter(java.lang.String)
	 */
	public String getInitParameter(String name) {
		return conf.get(name);
	}
	
	public String setInitParameter(String key, String value){
		return conf.put(key, value);
	}

	/* (non-Javadoc)
	 * @see org.pasoa.preserv.storage.InitialConfig#getInitParameterNames()
	 */
	public Enumeration getInitParameterNames() {
		return Collections.enumeration(conf.keySet());
	}

}
