package org.pasoa.preserv.storage.je;

import com.sleepycat.bind.tuple.TupleBinding;
import com.sleepycat.bind.tuple.TupleInput;
import com.sleepycat.bind.tuple.TupleOutput;

public class GPAKLightBinding extends TupleBinding {

    public GPAKLightBinding ()
    {
    }
    
    public Object entryToObject(TupleInput ti) {
        long   lik  = ti.readLong();
        int    vk   = ti.readInt();
        String lpid = ti.readString();
        int    at   = ti.readInt();
        
        GPAKWithPAssertionKindLight gpaklight =  new GPAKWithPAssertionKindLight(lik,vk,lpid,at);
        return gpaklight;
    }

    public void objectToEntry(Object obj, TupleOutput to) {
        GPAKWithPAssertionKindLight gpaklight = (GPAKWithPAssertionKindLight)obj;
        
        to.writeLong(gpaklight.getLocalInteractionKey());
        to.writeInt(gpaklight.getViewKind());
        to.writeString(gpaklight.getLocalPAssertionId());
        to.writeInt(gpaklight.getAssertionKind());
       
    }
}
