package org.pasoa.preserv.storage.mysql.test.scalability;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.io.StringReader;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.pasoa.preserv.storage.je.BerkeleyDBJEStorage2;
import org.pasoa.preserv.storage.mysql.Debug;
import org.pasoa.preserv.storage.mysql.MySQLStore;
import org.pasoa.pstructure.GlobalPAssertionKey;
import org.pasoa.pstructure.InteractionKey;
import org.pasoa.util.httpsoap.WSAddressEndpoint;
import org.pasoa.common.Constants;
import org.w3c.dom.Element;
import org.xml.sax.InputSource;
import sun.security.action.GetLongAction;

import com.sleepycat.bind.tuple.IntegerBinding;
import com.sleepycat.bind.tuple.StringBinding;
import com.sleepycat.je.Database;
import com.sleepycat.je.DatabaseConfig;
import com.sleepycat.je.DatabaseEntry;
import com.sleepycat.je.Environment;
import com.sleepycat.je.EnvironmentConfig;
import com.sleepycat.je.Transaction;

public class MySQLStraightSizeTest 
{
    public static void main (String args[]) throws Exception
    {
        // args[0] = inputFileName
        MySQLStraightSizeTest sst = new MySQLStraightSizeTest();
       
/*        sst.osTest();
        sst.dbTest(args[0], true);
        sst.dbTest(args[0], true);
        
        sst.dbTest(args[0], false);
        sst.dbTestWithTransactions(args[0], true);
        sst.dbTestWithTransactions(args[0], false);
*/
//        sst.recordTest(args[0], true);
//        sst.recordTest(args[0]);
        
    }
    
/*    public void osTest () throws Exception
    {
        File outputFile = File.createTempFile("output", ".tmp");
        outputFile.deleteOnExit();
        long startTime = System.currentTimeMillis();
        BufferedWriter bWriter = new BufferedWriter(new FileWriter(outputFile));
        for (int i = 0; i < 107374182; i++) {
            bWriter.write("outputplus");
        }
        bWriter.close();
        long endTime = System.currentTimeMillis();
        
        System.out.println("OSTest, file size=" + outputFile.length() + " time=" + (endTime - startTime));
        
    }
  */  
/*    public void dbTestWithTransactions (String inputFileName, boolean sync) throws Exception {
        File homeDir = File.createTempFile ("database", "");
        homeDir.delete ();
        homeDir.mkdir ();
        homeDir.deleteOnExit();
        
        EnvironmentConfig envConfig = new EnvironmentConfig ();
        envConfig.setAllowCreate (true);
        envConfig.setTransactional (true);
        envConfig.setTxnWriteNoSync(sync);
        Environment environ = new Environment (homeDir, envConfig);
        
        DatabaseConfig dbConfig = new DatabaseConfig ();
        dbConfig.setAllowCreate (true);
        dbConfig.setTransactional (true);

        Transaction psTxn = environ.beginTransaction (null, null);
        Database db = environ.openDatabase (psTxn, "somedb", dbConfig);
        psTxn.commit ();
         
        DatabaseEntry key = new DatabaseEntry();
        DatabaseEntry value = new DatabaseEntry();
        
        BufferedReader br = new BufferedReader (new FileReader(inputFileName));
        String input = "";
        String tmp = "";
        while ((tmp = br.readLine()) != null) {
            input = input + tmp;
        }
        br.close();
        
        StringBinding.stringToEntry(input, value);
        
        long startTime = System.currentTimeMillis(); 
        
        for (int i = 0; i < 10485; i++) {
           Transaction txn = environ.beginTransaction(null, null);
           IntegerBinding.intToEntry (i, key);
           db.put (txn, key, value);

           txn.commit ();
        }
        long endTime = System.currentTimeMillis();
        
        System.out.println("TransactionDB Time, Sync:" + sync + " "  + (endTime - startTime));
        
        db.close();
        environ.close();
    }
    
    public void dbTest (String inputFileName, boolean sync) throws Exception {
        File homeDir = File.createTempFile ("database", "");
        homeDir.delete ();
        homeDir.mkdir ();
        homeDir.deleteOnExit();
        
        EnvironmentConfig envConfig = new EnvironmentConfig ();
        envConfig.setAllowCreate (true);
        envConfig.setTransactional (false);
        envConfig.setTxnWriteNoSync(sync);
        Environment environ = new Environment (homeDir, envConfig);
        
        DatabaseConfig dbConfig = new DatabaseConfig ();
        dbConfig.setAllowCreate (true);
        dbConfig.setTransactional (false);

        Database db = environ.openDatabase (null, "somedb", dbConfig);
         
        DatabaseEntry key = new DatabaseEntry();
        DatabaseEntry value = new DatabaseEntry();
        
        BufferedReader br = new BufferedReader (new FileReader(inputFileName));
        String input = "";
        String tmp = "";
        while ((tmp = br.readLine()) != null) {
            input = input + tmp;
        }
        br.close();
        
        StringBinding.stringToEntry(input, value);
        
        long startTime = System.currentTimeMillis(); 
        
        for (int i = 0; i < 10485; i++) {
           IntegerBinding.intToEntry (i, key);
           db.put (null, key, value);

        }
        long endTime = System.currentTimeMillis();
        
        System.out.println("DB Time, Sync:" + sync + " "  + (endTime - startTime));
        
        db.close();
        environ.close();
    }
    */
    public void recordTest (String inputFileName, int n, PrintWriter out) throws Exception
    {
//       File homeDir = File.createTempFile ("database", "");
//       homeDir.delete ();
//       homeDir.mkdir ();
//       homeDir.deleteOnExit();
        
       BufferedReader br = new BufferedReader (new FileReader(inputFileName));
       String input = "";
       String tmp = "";
       while ((tmp = br.readLine()) != null) {
           input = input + tmp;
       }
       br.close();
       
//       BerkeleyDBJEStorage2 backend = new BerkeleyDBJEStorage2(homeDir.getAbsolutePath(), sync);
       MySQLStore backend = new MySQLStore();
//       backend.startRecordTiming();
       
       WSAddressEndpoint     sender   = new WSAddressEndpoint ("http://sender.com");
       WSAddressEndpoint     receiver = new WSAddressEndpoint ("http://receiver.com");
       InteractionKey ik = new InteractionKey(sender.getElement(), receiver.getElement(), "1");
       Element asserter = sender.getElement();
       DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
       dbf.setNamespaceAware(true);
       DocumentBuilder docBuilder = dbf.newDocumentBuilder();
//       String xmlData = "<d:data xmlns:d=\"http://www.d.com\">" + input + "</d:data>";
       String xmlData = input;
       Element assertion = docBuilder.parse(new InputSource (new StringReader (xmlData))).getDocumentElement();
       String str = "" + Math.random();
       long startTime = System.currentTimeMillis();
       for (int i = 0; i < n; i++) {
           GlobalPAssertionKey gpak = new GlobalPAssertionKey(ik, Constants.SENDER_VIEW_TYPE, i + str);
           backend.record(gpak, asserter,  assertion, Constants.ACTOR_STATE_PASSERTION_ELEMENT_NAME);
       }
       long endTime = System.currentTimeMillis();
//       Debug.msg(backend.stopRecordTiming());
       backend.shutdown();
       long elapsed = endTime-startTime;
       out.println(n + "\t" + elapsed);
       System.out.println("MySQL\t" + n + "\t" + elapsed);
    }
    
}
