package org.pasoa.preserv.xquery;

import java.util.List;
import java.util.Map;

public interface XQueryResolver {
    /**
     * @param query     The actual XQuery expression
     * @param documents A map from String to Document
     * @param variables A map from QName to Node, NodeList, String, Integer etc.
     */
    List resolve (String query, Map documents, Map variables) throws QueryProblem;
}
