/*
 * HTMLDisplay.java
 *
 * Created on 26 septembre 2006, 15:36
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview;

import java.awt.Dimension;
import javax.swing.Action;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.text.html.HTML;
import javax.swing.text.html.HTMLEditorKit;

/**
 * Create a window to display the html command list
 * @author tibo
 */
public class HTMLDisplay extends JDialog {
    
    /**
     * Creates a new instance of HTMLDisplay
     * @param jf main JFrame
     * @param html a string which contains a HTML text
     */
    public HTMLDisplay(JFrame jf, String html) {
        super(jf, false);
        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(":: Command List ::");
        setPreferredSize(new Dimension (870, 400));
        
        JTextPane jt = new JTextPane();

        jt.setContentType("text/html");
        jt.setEditable(false);
        jt.setText(html);

        jt.setCaretPosition(0);
        JScrollPane js = new JScrollPane(jt);
        //System.out.println(jt.getText());

        add(js);
        pack();
    }
    
}
