package org.pasoa.preview._old;

import java.util.HashMap;

import edu.uci.ics.jung.graph.ArchetypeVertex;
import edu.uci.ics.jung.graph.decorators.VertexStringer;

public class MapStringer implements VertexStringer
{
	private HashMap _vertexToLabel;
	
	public MapStringer()
	{
		_vertexToLabel = new HashMap();
	}
	
	public void addLabel (ArchetypeVertex v, String label) {
		_vertexToLabel.put(v, label);
	}
	
	public String getLabel(ArchetypeVertex v)
	{
		return (String)_vertexToLabel.get(v);
	}
}
