/*
 * IDrawable.java
 *
 * Created on 27 juillet 2006, 15:53
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.asserterview;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.awt.Shape;
import javax.swing.JTable;
import org.w3c.dom.Element;

/**
 * Interface for all the drawables objects
 * @author tibo
 */
public interface IDrawable {
    
    /**
     * the color for selected object
     */
    static Color selectColor = new JTable().getSelectionBackground();
    
    void draw(Graphics g);

    void setColor(Color c);

    boolean isSelected();
    
    void setSelected(boolean tf);
    
    boolean isDrawable();
    
    void setDrawable(boolean tf);
    
    public Element getElem();
    
    Shape getShape();
    
}
