/*
 * MouseListen.java
 *
 * Created on 2 aout 2006, 11:43
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.asserterview;

import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

/**
 * a mouse listener for the actor view
 * @author tibo
 */
public class MouseListen extends JCanvasMouseAdapter implements MouseWheelListener{
    
    //private AsserterView canvas;
    
    /**
     * Creates a new instance of MouseListen
     * @param canvas an actor view
     */
    public MouseListen(AsserterView canvas) {
		super(canvas);
		//this.canvas = canvas;
                canvas.addMouseWheelListener(this);
    }

    public void mouseWheelMoved(MouseWheelEvent e) {
        int notches = e.getWheelRotation();
        if(notches < 0){
            // wheel moved UP 
            if(canvas.scaleX >= 0.4 && canvas.scaleY >= 0.4){
                canvas.scaleX -= 0.1;
                canvas.scaleY -= 0.1;
            }
            canvas.repaint();
            canvas.getParent().repaint();
        }
        else {
            // wheel moved DOWN
             if(canvas.scaleX <= 100 && canvas.scaleY <= 100){
                canvas.scaleX += 0.1;
                canvas.scaleY += 0.1;
             }
            canvas.repaint();
            canvas.getParent().repaint();
        }
    }
    
}
