/*
 * PopupPAssertionWindow.java
 *
 * Created on 22 septembre 2006, 15:43
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.provenanceview;

import java.awt.Dimension;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextPane;
import org.pasoa.preview.treetable.MyTreeTable;
import org.pasoa.preview.treetable.XMLTreeTableCellRenderer;
import org.pasoa.preview.treetable.XMLTreeTableModel;
import org.pasoa.simpledom.DOMWriter;
import org.w3c.dom.Element;

/**
 * popup window to display the content of the PAssertion
 * @author tibo
 */
public class PopupPAssertionWindow extends JDialog{

    private JTabbedPane jTabbedPane1;

    private JScrollPane jScrollPane2;

    private JScrollPane jScrollPane3;

    private JTextArea jTextArea2;

    private XMLTreeTableModel xmltreetablemodel;

    private MyTreeTable treeTable;
    
    /**
     * Creates a new instance of PopupPAssertionWindow
     * @param parent the parent jframe
     * @param elem XML element to display
     * @param title the title of the popup window
     */
    public PopupPAssertionWindow(JFrame parent, Element elem, String title) {
        super(parent, title, false);
        
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        jScrollPane3 = new javax.swing.JScrollPane();

        jTextArea2.setEditable(false);
        jTextArea2.setText(DOMWriter.writeToString(elem, true));
        
        jTextArea2.setLineWrap( true );
        jTextArea2.setWrapStyleWord( true );

        jScrollPane2.setPreferredSize(new Dimension(1, 1));
        jScrollPane2.setViewportView(jTextArea2);
        jTextArea2.setCaretPosition(0);
        xmltreetablemodel = new XMLTreeTableModel(elem);
        treeTable = new MyTreeTable(xmltreetablemodel, parent);
        treeTable.getTree().setCellRenderer(new XMLTreeTableCellRenderer());

        jScrollPane3.setPreferredSize(new Dimension(1, 1));
        jScrollPane3.setViewportView(treeTable);


        jTabbedPane1.addTab("Node mode", jScrollPane3);
        jTabbedPane1.addTab("Text mode", jScrollPane2);

        add(jTabbedPane1);
        
        setSize(new Dimension(300, 300));
        
        setVisible(true);
    }
 
}
