/*
 * ColListener.java
 *
 * Created on 14 juillet 2006, 10:53
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.tableview;

/**
 *
 * @author tibo
 */
 
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*; 
import org.pasoa.preview.*;
import org.pasoa.preview.asserterview.AsserterView;
import org.pasoa.preview.utils.ErreurDialog;
import org.pasoa.preview.utils.Progression;

/**
 * a mouse listener for the column of main table
 * @author tibo
 */
class ColListener extends MouseAdapter
{
    JScrollPane asserter;
    JTabbedPane jtp;
    Controller control;
    Vector columnNames;
    JFrame jf;

    Vector<Vector> interactionsDataGrid;
    private JScrollPane infobox;
        
    public ColListener(JTabbedPane jtp, Controller control, Vector columnNames, JFrame jf, JScrollPane infobox, Vector<Vector> interactionsDataGrid) {
        this.jtp = jtp;
        this.control = control;
        this.columnNames = columnNames;
        this.jf = jf;
        this.infobox = infobox;
        this.interactionsDataGrid = interactionsDataGrid;
    }
 
    public void mousePressed(MouseEvent e)
    {
        JTableHeader header = (JTableHeader) e.getSource();
        if(header.columnAtPoint(e.getPoint()) >= 0 ){
        final int cindex = header.columnAtPoint(e.getPoint());

        if(e.getClickCount() == 1) {
            TableColumn tcol = header.getColumnModel().getColumn(cindex);
            Mycellrender mcr = (Mycellrender)tcol.getCellRenderer();

            mcr.setcol(cindex);
            header.getTable().repaint();
        }
        else  {
            if(e.getClickCount()==2){
                this.asserter = new JScrollPane();

                Runnable go = new Runnable() {
                    public void run() {
                        Progression pgr = new Progression(jf);
                        try {

                            pgr.startProgress();
                        AsserterView av = new AsserterView(control, ((AsserterIdentity)columnNames.elementAt(cindex)), columnNames, jf, jtp, infobox,interactionsDataGrid, false);

                        int removeTab = -1;
                        removeTab = jtp.indexOfTab(((AsserterIdentity)columnNames.elementAt(cindex)).getShortName() + "View");
                        if(removeTab!=-1){
                            jtp.removeTabAt(removeTab);
                        }

                        asserter.setViewportView(av);
                        jtp.addTab(
                                ((AsserterIdentity)columnNames.elementAt(cindex)).getShortName() + "View", 
                                null, 
                                asserter,
                                "This is one Asserter View");
                        jtp.setSelectedIndex(jtp.getTabCount()-1);
                        av.requestFocusInWindow();
                        pgr.stopProgress();

                    } catch (Exception ex) {
                        if(Controller.debug)ErreurDialog.afficher(jf, "Unable to initialize Asserterview", 
                            ex.getMessage(),ex.getStackTrace());
                        else ErreurDialog.afficher(jf, "Unable to initialize Asserterview", ex.getMessage());
                     pgr.stopProgress();
                    }

                    asserter.repaint();
                    }
                };
                Thread t = new Thread(go);
                t.start();

            }
        }
        }
     
    } 
}
 