/*
 * Mycellrender.java
 *
 * Created on 14 juillet 2006, 10:55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.tableview;

/**
 *
 * @author tibo
 */

import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*; 
import org.pasoa.preview.*;


/**
 * a cell renderer for the main table
 * @author tibo
 */
class Mycellrender extends DefaultTableCellRenderer
{
    int selectcol = -1;

    private Vector<Vector> data;

    int selectrow = -1;

    private int max;
 
    /**
     * a new instance of Mycellrender
     * @param data Vector<Vector<int>> the number of interactions between two asserter identity
     * @param m 
     */
    public Mycellrender(Vector<Vector> data, int m){
        this.data = data;
        this.max = m;
    }
    
    public Component getTableCellRendererComponent(JTable jt,Object value,
                          boolean isselected, boolean hasfocus,int row,int col)
    {
        super.getTableCellRendererComponent(jt,value,isselected,hasfocus,row,col);
        
        setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        setVerticalAlignment(javax.swing.SwingConstants.CENTER);

        //System.out.println(jt.getValueAt(row, col).toString());
        int tmp = Integer.parseInt(data.elementAt(row).elementAt(col).toString());
        if(tmp != 0){
            int r = (254/max) * tmp;
            setBackground(new Color(255, 255 - r, 255 - r));
            
           //if (col == selectcol || row == selectrow)
               //setBorder( UIManager.getBorder("Table.focusCellHighlightBorder") );
           if(isselected){
                setBackground(jt.getSelectionBackground());
                //setBackground(jt.getSelectionBackground());
                setBorder( UIManager.getBorder("Table.focusCellHighlightBorder") );
            }
        }
        else {
            setBackground(null);
            if( row % 2 == 0 ) setBackground(new Color(230, 230, 230));
            //if (col == selectcol || row == selectrow)
            //    setBorder( UIManager.getBorder("Table.focusCellHighlightBorder") );
            if(isselected){
                
            if( row % 2 == 0 ) setBackground(new Color(230, 230, 230));
            else setBackground(null);
                setBorder( null);
            }
        }
        return this;
    }
 
    public void setcol(int index)
    {
        if (selectcol == index)
            selectcol = -1; 
        else
            selectcol = index;
    }
 
    public void setrow(int index)
    {
        if (selectrow == index)
            selectrow = -1; 
        else
            selectrow = index;
    }
}
 