/*
 * SelectionListener.java
 *
 * Created on 14 juillet 2006, 10:56
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.pasoa.preview.tableview;

/**
 *
 * @author tibo
 */
 

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*; 
import org.pasoa.preview.*;


class SelectionListener implements ListSelectionListener
{
    JTable table;
 
    public SelectionListener(JTable t) { table = t; }
 
    public void valueChanged(ListSelectionEvent e)
    {
        if(!e.getValueIsAdjusting())
        {
            ListSelectionModel model = (ListSelectionModel)e.getSource();
            Mycellrender mcr = (Mycellrender)table.getCellRenderer(0,0);
            int anchorRowIndex = table.getSelectionModel().getAnchorSelectionIndex();
            int anchorColIndex = table.getColumnModel().getSelectionModel().
                                          getAnchorSelectionIndex();
            boolean change = false;
            if(anchorRowIndex != mcr.selectrow)
            {
                mcr.setrow(mcr.selectrow);
                change = true;
            }
            if(anchorColIndex != mcr.selectcol)
            {
                mcr.setcol(mcr.selectcol);
                change = true;
            }
            if(change)
                table.repaint();
        }
    }
}