package org.pasoa.preserv.index;

import org.pasoa.pstructure.GlobalPAssertionKey;
import org.pasoa.pstructure.InteractionKey;
import org.pasoa.pstructure.InteractionRecord;
import org.pasoa.pstructure.PAssertion;
import org.pasoa.pstructure.View;

public interface Index {
    InteractionRecord findInteractionRecord (InteractionKey key)                  throws IndexProblem;
    PAssertion        findPAssertion        (GlobalPAssertionKey gpak)            throws IndexProblem;
    View              findView              (InteractionKey key, String viewKind) throws IndexProblem;
}
