package org.pasoa.preserv.storage.je;


import com.sleepycat.bind.EntryBinding;
import com.sleepycat.bind.tuple.LongBinding;
import com.sleepycat.bind.tuple.TupleBinding;
import com.sleepycat.je.DatabaseEntry;
import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.SecondaryDatabase;
import com.sleepycat.je.SecondaryKeyCreator;

public class GPAKSecondaryKeyCreator implements SecondaryKeyCreator
{
    
    public GPAKSecondaryKeyCreator ()
    {
    }
    
    public boolean createSecondaryKey(SecondaryDatabase secondary,
                                      DatabaseEntry key,
                                      DatabaseEntry data,
                                      DatabaseEntry result)
        throws DatabaseException 
    {
        long localIk = TupleBinding.entryToInput(key).readLong();
        LongBinding.longToEntry (localIk, result);
        
        return true;
    }
}
