package org.pasoa.preserv.storage.je;

import com.sleepycat.bind.tuple.TupleBinding;
import com.sleepycat.bind.tuple.TupleInput;
import com.sleepycat.bind.tuple.TupleOutput;

public class LocalViewKeyBinding extends TupleBinding {

 
    public Object entryToObject(TupleInput ti) {
        long lik = ti.readLong();
        int  vk  = ti.readInt();
        
        return new LocalViewKey (lik, vk);
    }

    public void objectToEntry(Object obj, TupleOutput to) {
        LocalViewKey lvk = (LocalViewKey)obj;
        to.writeLong(lvk.getLocalInteractionKey());
        to.writeInt(lvk.getLocalViewKind());

    }

}
