package org.pasoa.preserv.test.scalability;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

public class ScalabilityProps
{
    public static Properties _properties = null;

    private static String PROPERTY_NAME = "ScalabilityTestProps";
    
    static 
    {
        try {
            if (System.getProperty(PROPERTY_NAME) != null) {
                _properties = new Properties();
                _properties.load(new FileInputStream(System.getProperty(PROPERTY_NAME)));
                _properties.list(System.out);
            }
        } 
        catch (FileNotFoundException fnfe) {
            System.out.println("ScalabilityProperties: The file specified by ScalabilityTestProps does not exist");
            System.out.println("ScalabilityProperites: The file specified was " + System.getProperty(PROPERTY_NAME));
        }
        catch (IOException ioe) {
            System.out.println("ScalabilityProperties: Unable to load file");
        }
    }
    
    public static String getProperty (String property) 
    {
        return _properties.getProperty(property);
    }
}
