/********************************************************************************
 * Created on 2006 May 23
 *
 * Copyright (c) 2006 University of Southampton
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy 
 * of this software and associated documentation files (the "Software"), to deal 
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS 
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
 * SOFTWARE.
 *******************************************************************************/

package org.pasoa.preserv.xquery;

import org.pasoa.common.Constants;
import org.pasoa.simpledom.SimpleAttr;
import org.pasoa.simpledom.SimpleDocument;
import org.pasoa.simpledom.SimpleElement;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class QueryConstants {
    public static Document errorMsg (String message) {
        Document fault;
        Element  error;
        
        fault = new SimpleDocument ();
        error = new SimpleElement  (fault, Constants.PSTRUCT_NS, "error");
        fault.appendChild (error);
        error.appendChild (new SimpleAttr (fault, Constants.PSTRUCT_NS, "message", message));
        
        return fault;
    }
}
