package org.pasoa.storeclient.messages;

import org.pasoa.pstructure.Record;
import org.pasoa.pstructure.serialiser.PStructureSerialiser;
import org.pasoa.simpledom.DOMSerialiser;
import org.pasoa.util.httpsoap.SOAPDocument;

public class RecordRequestDocument extends SOAPDocument {
    public RecordRequestDocument (Record request) {
        DOMSerialiser builder = new DOMSerialiser (body);
        
        builder.append (new PStructureSerialiser ().serialiseRecordRequest (request));
    }
}
