package org.pasoa.storeclient.messages;

import org.pasoa.pstructure.PHeader;
import org.pasoa.pstructure.serialiser.PStructureSerialiser;
import org.pasoa.util.httpsoap.SOAPDocument;
import org.w3c.dom.Element;

public class SOAPMessageWithPHeader extends SOAPDocument {
    public SOAPMessageWithPHeader (Element bodyContent, PHeader pheader) {
        body.appendChild (bodyContent);
        header.appendChild (new PStructureSerialiser ().serialisePHeader (pheader).getDocumentElement ());
    }
}
