package org.pasoa.storeclient.test;

import java.io.File;
import java.io.FileOutputStream;
import java.net.URL;

import org.pasoa.preserv.test.LocalTestbed;
import org.pasoa.simpledom.DOMWriter;
import org.pasoa.storeclient.ClientLib;
import org.w3c.dom.Document;

public class GetStoreContents 
{
    public static void main (String[] args) throws Exception
    { 
        if (args.length != 2) {
            System.out.println("Usage: java GetStoreContents <provenance store xquery url> <output file path>");
            System.exit(0);
        }
        System.out.println("Getting store contents");
        ClientLib clientLib = new ClientLib();
        Document result = clientLib.query("$ps:pstruct", new URL (args[0]));
        FileOutputStream fos = new FileOutputStream (new File (args[1]));
        DOMWriter dWriter = new DOMWriter (fos);
        dWriter.setFormatted(true);
        dWriter.write(result);
        System.out.println("Store contents have been put into " + args[1]);
        
        
        /*LocalTestbed testbed = new LocalTestbed (args[0]);
        System.out.println ("Prints the contents of the provenance store at " + args[0]);
        Document result = testbed.getStoreContents();
        System.out.println (DOMWriter.writeToString (result, true));
        */
    }
}
