package org.pasoa.storeclient.wrappers.java.util;

import java.net.URL;
import org.pasoa.simpledom.SimpleDocument;
import org.pasoa.simpledom.SimpleElement;
import org.pasoa.simpledom.SimpleText;
import org.pasoa.storeclient.wrappers.java.ActorStateAsserter;
import org.w3c.dom.Element;

public class TimestampAsserter extends ActorStateAsserter {
    public TimestampAsserter (URL provenanceStore, boolean isSenderView) {
        super (provenanceStore, isSenderView, getTimestamp ());
    }
    
    private static Element getTimestamp () {
        SimpleDocument doc = new SimpleDocument ();
        SimpleElement  time;
        
        time = new SimpleElement (doc, "http://www.example.com", "time");
        time.appendChild (new SimpleText (doc, Long.toString (System.currentTimeMillis ())));
        doc.appendChild (time);
        
        return time;
    }
}
