package org.pasoa.storeclient.wrappers.script;

import java.util.Map;
import org.pasoa.storeclient.wrappers.java.JavaService;

public class ScriptService extends JavaService {
    private String line;
    
    public ScriptService (String name, String asserterIdentity) {
        super (name, asserterIdentity);
        line = name;
    }
    
    public ScriptService (Map config) {
        super (config);
        line = getName ();
    }
    
    public void initialise (String[] confargs) {
        for (int index = 1; index < confargs.length; index += 1) {
            line = line + " " + confargs [index];
        }
        super.initialise (confargs);
    }
    
    public void run () {
        try {
System.out.println ("running line: " + line);
            Runtime.getRuntime ().exec (line).waitFor ();
        } catch (Exception problem) {
            throw new RuntimeException (problem);
        }
    }
}
