package org.pasoa.util.httpsoap;

import org.pasoa.simpledom.SimpleDocument;
import org.pasoa.simpledom.SimpleElement;
import org.pasoa.simpledom.SimpleText;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * A simple class for taking making a URL into a WS-addressing endpoint
 * xml representation
 * @author sm
 *
 */
public class WSAddressEndpoint {
    private String _url;
    
    public static final String wsaNamespace = "http://schemas.xmlsoap.org/ws/2004/03/addressing";
    
    public WSAddressEndpoint (String url) {
        _url = url;
    }
    
    public Element getElement () {
        return getDocument ().getDocumentElement ();
    }
    
    public Document getDocument () {
        SimpleDocument doc = new SimpleDocument ();
        //SimpleElement  epr = new SimpleElement  (doc, wsaNamespace, "EndpointReference");
        SimpleElement  add = new SimpleElement  (doc, wsaNamespace, "Address");
        
        doc.appendChild (add);
        //epr.appendChild (add);
        add.appendChild (new SimpleText (doc, _url));
        
        return doc;
    }
}
